% this script is used to read the A B N C matrices of the NREL 5MW wind turbine from txt files

%% A matrix

fileAmatrix = fopen('A.txt','r+');
scanfile = textscan(fileAmatrix, '%s', 'delimiter', '\n');
scanstr = scanfile{1,1};

size_infoA = scanstr{1,1};
size_A = sscanf(size_infoA,'%f');
row_A = size_A(1);
column_A = size_A(2);

A_wt_matrix = zeros(row_A,column_A);
n = 2;

for j = 1:column_A
    for i = 1:row_A
        A_wt_matrix(i,j) = str2double(scanstr{n});
        n = n+1;
    end
end

% rearrange rows and columns
A = A_wt_matrix([1:6 79:84 7:78 85:493],:);
clear A_wt_matrix
A_wt_matrix = A(:,[1:6 79:84 7:78 85:493]);

clear scanstr

%% B matrix

fileBmatrix = fopen('B.txt','r+');
scanfile = textscan(fileBmatrix, '%s', 'delimiter', '\n');
scanstr = scanfile{1,1};

size_infoB = scanstr{1,1};
size_B = sscanf(size_infoB,'%f');
row_B = size_B(1);
column_B = size_B(2);

B_wt_matrix = zeros(row_B,column_B);
n = 2;

for j = 1:column_B
    for i = 1:row_B
        B_wt_matrix(i,j) = str2double(scanstr{n});
        n = n+1;
    end
end

% rearrange rows and columns
B = B_wt_matrix([1:6 79:84 7:78 85:493],:);
clear B_wt_matrix
B_wt_matrix = B;

clear scanstr

%% C matrix

fileLmatrix = fopen('C.txt','r+');
scanfile = textscan(fileLmatrix, '%s', 'delimiter', '\n');
scanstr = scanfile{1,1};

size_infoC = scanstr{1,1};
size_C = sscanf(size_infoC,'%f');
row_C = size_C(1);
column_C = size_C(2);

C_wt_matrix = zeros(row_C,column_C);
n = 2;

for j = 1:column_C
    for i = 1:row_C
        C_wt_matrix(i,j) = str2double(scanstr{n});
        n = n+1;
    end
end

% rearrange rows and columns
C = C_wt_matrix(:,[1:6 79:84 7:78 85:493]);
clear C_wt_matrix
C_wt_matrix = C;

clear scanstr

%% Nmatrix

fileNmatrix = fopen('N.txt','r+');
scanfile = textscan(fileNmatrix, '%s', 'delimiter', '\n');
scanstr = scanfile{1,1};

size_infoN = scanstr{1,1};
size_N = sscanf(size_infoN,'%f');
row_N = size_N(1);
column_N = size_N(2);

N_wt_matrix = zeros(row_N,column_N);
n = 2;

for j = 1:column_N
    for i = 1:row_N
        N_wt_matrix(i,j) = str2double(scanstr{n});
        n = n+1;
    end
end

% rearrange rows and columns
N = N_wt_matrix([1:6 79:84 7:78 85:493],:);
clear N_wt_matrix
N_wt_matrix = N(:,[1:6 79:84 7:78 85:493]);

clear scanstr